=== debian/changelog ===
goxel (0.7.1-2) unstable; urgency=medium

  * Initial release (Closes: #876204)

 -- Federico Ceratto <federico@debian.org>  Tue, 03 Oct 2017 13:47:45 +0100
