=== SConstruct ===
--- 
+++ 
@@ -14,6 +14,7 @@
 emscripten = ARGUMENTS.get('emscripten', 0)
 werror = int(ARGUMENTS.get("werror", 1))
 clang = int(ARGUMENTS.get("clang", 0))
+argp_standalone = int(ARGUMENTS.get("argp_standalone", 0))
 sound = False
 
 if profile: debug = 0
@@ -28,9 +29,12 @@
 # Asan & Ubsan (need to come first).
 if debug and target_os == 'posix':
     env.Append(CCFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
-               LIBS=['asan', 'ubsan'])
+               LINKFLAGS=['-fsanitize=address', '-fsanitize=undefined'])
+    if not clang:
+        env.Append(LIBS=['asan', 'ubsan'])
 
-env.Append(CFLAGS= '-Wall -std=gnu99 -Wno-unknown-pragmas',
+env.Append(CFLAGS= '-Wall -std=gnu99 -Wno-unknown-pragmas '
+                   '-Wno-unknown-warning-option',
            CXXFLAGS='-std=gnu++11 -Wall -Wno-narrowing '
                     '-Wno-unknown-pragmas -Wno-unused-function'
         )
@@ -55,11 +59,16 @@
 
 if target_os == 'posix':
     env.Append(LIBS=['GL', 'm', 'z'])
+    if not conf.CheckDeclaration('__GLIBC__', includes='#include <features.h>'):
+        env.Append(LIBS=['argp'])
     # Note: add '--static' to link with all the libs needed by glfw3.
     env.ParseConfig('pkg-config --libs glfw3')
 
 if glut:
     env.Append(CCFLAGS='-DUSE_GLUT=1', LIBS='glut')
+
+if argp_standalone:
+    env.Append(LIBS='argp')
 
 if target_os == 'msys':
     env.Append(CCFLAGS='-DNO_ARGP')
@@ -117,4 +126,11 @@
     env.Append(LIBS='openal')
     env.Append(CCFLAGS='-DSOUND=OPENAL')
 
+# Append external environment flags
+env.Append(
+    CFLAGS=os.environ.get("CFLAGS", "").split(),
+    CXXFLAGS=os.environ.get("CXXFLAGS", "").split(),
+    LINKFLAGS=os.environ.get("LDFLAGS", "").split()
+)
+
 env.Program(target='goxel', source=sources)
