=== debian/changelog ===
goxel (0.7.2-1) unstable; urgency=medium

  * New upstream release
  * Add supported architectures (Closes: #882530)
  * Update description (Closes: #882516)

 -- Federico Ceratto <federico@debian.org>  Fri, 24 Nov 2017 23:54:57 +0000
