=== debian/control ===
Source: goxel
Section: graphics
Priority: optional
Maintainer: Federico Ceratto <federico@debian.org>
Build-Depends: debhelper (>= 10~),
 help2man,
 libglfw3-dev,
 libgtk-3-dev,
 scons,
 uthash-dev
Standards-Version: 4.1.1
Homepage: https://github.com/guillaumechereau/goxel
Vcs-Git: https://anonscm.debian.org/collab-maint/goxel.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/goxel.git

Package: goxel
Architecture: amd64 arm64 armel armhf i386 m68k mips mips64el mipsel powerpc ppc64 ppc64el s390x sh4 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 3D voxel editor
 Goxel is a 3D program that lets you create voxel volumes.
 It supports 24 bits RGB colors, unlimited scene size and undo buffers.
 Layers, procedural generation and Marching Cube rendering.
 Exports to obj, pyl, magica voxel, png, qubicle, povray, and more
