=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
VERSION ?= $(shell dpkg-parsechangelog --show-field Version)

%:
	dh $@

override_dh_auto_clean:
	scons -c
	rm -rf .sconf_temp config.log debian/goxel.1 goxel.xpm goxel.png

override_dh_auto_build:
	mv ext_src .ext_src
	mkdir ext_src
	cp -a .ext_src/imgui ext_src
	cp -a .ext_src/inih ext_src
	cp -a .ext_src/noc ext_src
	cp -a .ext_src/stb ext_src
	rm -rf .ext_src
	scons debug=0 -j 8 --no-cache
	cp -a ./osx/goxel/goxel/Assets.xcassets/AppIcon.appiconset/64.png ./goxel.png

override_dh_installman:
	help2man -N --no-discard-stderr \
		--no-info --version-string="${VERSION}" \
		-n "3D voxel editor" ./goxel > debian/goxel.1
	dh_installman ./debian/goxel.1
