=== SConstruct ===
--- 
+++ 
@@ -15,6 +15,7 @@
 werror = int(ARGUMENTS.get("werror", 1))
 clang = int(ARGUMENTS.get("clang", 0))
 argp_standalone = int(ARGUMENTS.get("argp_standalone", 0))
+cycles = int(ARGUMENTS.get('cycles', 1))
 sound = False
 
 if os.environ.get('CC') == 'clang': clang = 1
@@ -28,11 +29,17 @@
     env.Replace(CC='clang', CXX='clang++')
 
 # Asan & Ubsan (need to come first).
+# Cycles doesn't like libasan with clang, so we only use it on
+# C code with clang.
 if debug and target_os == 'posix':
-    env.Append(CCFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
-               LINKFLAGS=['-fsanitize=address', '-fsanitize=undefined'])
     if not clang:
-        env.Append(LIBS=['asan', 'ubsan'])
+        env.Append(CCFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
+                   LINKFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
+                   LIBS=['asan', 'ubsan'])
+    else:
+        env.Append(CFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
+                   LINKFLAGS=['-fsanitize=address', '-fsanitize=undefined'])
+
 
 env.Append(CFLAGS= '-Wall -std=gnu99 -Wno-unknown-pragmas '
                    '-Wno-unknown-warning-option',
@@ -45,9 +52,9 @@
 
 if debug:
     if env['CC'] == 'gcc':
-        env.Append(CFLAGS='-Og')
+        env.Append(CFLAGS='-Og', CXXFLAGS='-O1')
 else:
-    env.Append(CCFLAGS='-Ofast -DNDEBUG')
+    env.Append(CCFLAGS='-DNDEBUG', CFLAGS='-Ofast', CXXFLAGS='-Ofast')
 
 if profile or debug:
     env.Append(CCFLAGS='-g')
@@ -73,6 +80,8 @@
 
 if target_os == 'msys':
     env.Append(CCFLAGS='-DNO_ARGP')
+    env.Append(CXXFLAGS=['-Wno-attributes', '-Wno-unused-variable',
+                         '-DFREE_WINDOWS'])
     env.Append(LIBS=['glfw3', 'opengl32', 'Imm32', 'gdi32', 'Comdlg32',
                      'z', 'tre', 'intl', 'iconv'],
                LINKFLAGS='--static')
@@ -91,11 +100,54 @@
 
 sources += glob.glob('ext_src/imgui/*.cpp')
 env.Append(CPPPATH=['ext_src/imgui'])
-env.Append(CXXFLAGS='-DIMGUI_INCLUDE_IMGUI_USER_INL')
+env.Append(CXXFLAGS=['-DIMGUI_INCLUDE_IMGUI_USER_INL',
+                     '-DIMGUI_DISABLE_OBSOLETE_FUNCTIONS'])
 
 sources += glob.glob('ext_src/inih/*.c')
 env.Append(CPPPATH=['ext_src/inih'])
 env.Append(CFLAGS='-DINI_HANDLER_LINENO=1')
+
+# Cycles rendering support.
+if cycles:
+    sources += glob.glob('ext_src/cycles/src/util/*.cpp')
+    sources = [x for x in sources if not x.endswith('util_view.cpp')]
+    sources += glob.glob('ext_src/cycles/src/bvh/*.cpp')
+    sources += glob.glob('ext_src/cycles/src/render/*.cpp')
+    sources += glob.glob('ext_src/cycles/src/graph/*.cpp')
+    sources = [x for x in sources if not x.endswith('node_xml.cpp')]
+
+    sources += glob.glob('ext_src/cycles/src/device/device.cpp')
+    sources += glob.glob('ext_src/cycles/src/device/device_cpu.cpp')
+    sources += glob.glob('ext_src/cycles/src/device/device_memory.cpp')
+    sources += glob.glob('ext_src/cycles/src/device/device_denoising.cpp')
+    sources += glob.glob('ext_src/cycles/src/device/device_split_kernel.cpp')
+    sources += glob.glob('ext_src/cycles/src/device/device_task.cpp')
+
+    sources += glob.glob('ext_src/cycles/src/kernel/kernels/cpu/*.cpp')
+    sources += glob.glob('ext_src/cycles/src/subd/*.cpp')
+
+    env.Append(CPPPATH=['ext_src/cycles/src'])
+    env.Append(CPPPATH=['ext_src/cycles/third_party/atomic'])
+    env.Append(CPPFLAGS=[
+        '-DCYCLES_STD_UNORDERED_MAP',
+        '-DCCL_NAMESPACE_BEGIN=namespace ccl {',
+        '-DCCL_NAMESPACE_END=}',
+        '-DWITH_CUDA_DYNLOAD',
+        '-DWITHOUT_OPENIMAGEIO',
+        '-DWITH_GLEW_MX',
+        '-DWITH_CYCLES',
+    ])
+    # Try to improve compilation speed on linux.
+    if not clang: env.Append(CPPFLAGS='-fno-var-tracking-assignments')
+    # This seems to fix a crash on windows.
+    if target_os == 'msys':
+        env.Append(CXXFLAGS='-msse2 -O3 -fno-tree-slp-vectorize')
+
+env.Append(CPPFLAGS=['-Wno-sign-compare', '-Wno-strict-aliasing',
+                     '-Wno-uninitialized'])
+if clang:
+    env.Append(CPPFLAGS=['-Wno-overloaded-virtual'])
+
 
 if target_os == 'posix':
     env.ParseConfig('pkg-config --cflags --libs gtk+-3.0')
