=== debian/changelog ===
goxel (0.8.0-1) unstable; urgency=medium

  * New upstream release (Closes: #906469, #891888)

 -- Federico Ceratto <federico@debian.org>  Sat, 18 Aug 2018 11:52:36 +0100

goxel (0.7.3-1) unstable; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Sun, 18 Mar 2018 19:44:50 +0000
