=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk  # provides DEB_VERSION

%:
	dh $@

override_dh_auto_clean:
	scons -c
	rm -rf .sconf_temp config.log debian/goxel.1 goxel.xpm goxel.png
	if [ -d .ext_src ]; then rm ext_src -rf; mv .ext_src ext_src; fi

override_dh_auto_build:
	mv ext_src .ext_src
	mkdir ext_src
	cp -a .ext_src/imgui ext_src
	cp -a .ext_src/noc ext_src
	cp -a .ext_src/inih ext_src
	cp -a .ext_src/stb ext_src
	cp -a .ext_src/cycles ext_src
	scons cycles=0 debug=0 -j 8 --no-cache
	cp -a ./osx/goxel/goxel/Assets.xcassets/AppIcon.appiconset/64.png ./goxel.png
	rm ext_src -rf
	mv .ext_src ext_src

override_dh_installman:
	help2man -N --no-discard-stderr \
		--no-info --version-string="$(DEB_VERSION)" \
		-n "3D voxel editor" ./goxel > debian/goxel.1
	dh_installman ./debian/goxel.1

override_dh_usrlocal:
	true

override_dh_auto_install:
	dh_auto_install
	rm debian/goxel/usr/local/bin/goxel
