## goxel 0.8.1

=== Makefile ===
--- 
+++ 
@@ -12,10 +12,6 @@
 
 run:
 	./goxel
-
-.PHONY: js
-js:
-	$(EMSCRIPTEN)/emscons scons debug=0 emscripten=1
 
 clean:
 	scons -c
