=== debian/changelog ===
goxel (0.8.1-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:42:52 +0100

goxel (0.8.1-1) unstable; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Sat, 29 Sep 2018 16:30:40 +0100

goxel (0.8.0-2) unstable; urgency=medium

  * Fix install paths (Closes: #907448)

 -- Federico Ceratto <federico@debian.org>  Mon, 17 Sep 2018 19:52:51 +0100
