=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Priority: optional
 Maintainer: Federico Ceratto <federico@debian.org>
 Build-Depends: debhelper (>= 11~),
+ clang,
  help2man,
  libglfw3-dev,
  libgtk-3-dev,
  libinih-dev,
  scons,
  uthash-dev
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Homepage: https://github.com/guillaumechereau/goxel
 Vcs-Git: https://salsa.debian.org/debian/goxel.git
 Vcs-Browser: https://salsa.debian.org/debian/goxel
